<TeXmacs|1.0.7.20>

<style|<tuple|old-beamer|vdh|beamer-lebreton|beamer-bertho-block|framed-program>>

<\body>
  <\hide-preamble>
    <assign|strong-color|black>
  </hide-preamble>

  <screens|<\shown>
    <\doc-data|<doc-title|<new-line>Hensel lifting:<new-line> Newton
    iteration and relaxed algorithms>>
      \;
    </doc-data|<\doc-note>
      <with-TeXmacs-text>
    </doc-note>|<doc-author|<author-data|<author-name|Romain
    Lebreton>|<\author-affiliation>
      \;
    </author-affiliation>|<\author-affiliation>
      \;

      \;

      \;

      \;

      SCG Lab Meeting

      \;

      October 11th, 2013

      \;

      \;

      \;

      \;

      \;

      \;
    </author-affiliation>||>>>
  </shown>|<\hidden>
    <tit|Setting>

    \;

    <\itemize>
      <item>We want to solve the polynomial equation over
      <math|\<bbb-Q\><around*|[|<around*|[|T|]>|]>>:

      <\equation*>
        P<around*|(|Y|)>=Y<rsup|2>-Y+T\<in\><around*|(|\<bbb-Q\><around*|[|<around*|[|T|]>|]>|)><around*|[|Y|]>
      </equation*>

      <item>Consider the <em|regular> modular root <math|y<rsub|0>=0> of
      <math|P<around*|(|Y|)>>, <em|i.e.>

      <\equation*>
        P<around*|(|y<rsub|0>|)>=0 <bmod>T<text| and
        >P<rprime|'><around*|(|y<rsub|0>|)>\<neq\>0 <bmod>T.
      </equation*>

      <item>Since <math|P<rprime|'><around*|(|y<rsub|0>|)>\<neq\>0 <bmod>T>,
      <em|Hensel's Lemma> ensure that <math|\<exists\>!y\<in\>\<bbb-Q\><around*|[|<around*|[|T|]>|]>>
      such that

      <\equation*>
        P<around*|(|y|)>=0,<space|1em>y=y<rsub|0> <bmod>T.
      </equation*>
    </itemize>

    <\Example>
      The lifted root <math|y> from <math|y<rsub|0>> is

      <\equation*>
        y=<frac|1-<sqrt|1-4*T>|2>=T+T<rsup|2>+2*T<rsup|3>+5*T<rsup|4>+\<cal-O\><around*|(|T<rsup|5>|)>.
      </equation*>
    </Example>

    \;
  </hidden>|<\hidden>
    <tit|Our goal>

    \;

    \;

    <Definition|<em|Hensel lifting> is the process to compute <math|y> from
    <math|y<rsub|0>> and <math|P>.>

    \;

    \;

    <\redblocktit|<with|font-series|bold|This talk.>>
      We will show how to perform Hensel lifting using

      <\enumerate>
        <item>Newton's iteration

        <item>Relaxed algorithms
      </enumerate>
    </redblocktit>
  </hidden>|<\hidden>
    <tit|Newton's iteration>

    <strong|Input:>

    <\itemize>
      <item>A polynomial equation <math|P\<in\><around*|(|\<bbb-Q\><around*|[|<around*|[|T|]>|]>|)><around*|[|Y|]>>

      <item>A regular modular root <math|y<rsub|0>\<in\>\<bbb-Q\>> of
      <math|P>

      <item>A precision <math|2<rsup|N>\<in\>\<bbb-N\>>
    </itemize>

    <strong|Output:>

    <\itemize>
      <item>The unique lifted root <math|y\<in\>\<bbb-Q\><around*|[|<around*|[|T|]>|]>>
      at precision <math|2<rsup|N>>, <em|i.e.> modulo
      <math|T<rsup|2<rsup|N>>>
    </itemize>

    \;

    <\named-algorithm|>
      <math|r=y<rsub|0>>

      <strong|for> <math|i> <strong|from> <math|1> <strong|to> <math|N>

      <\indent>
        <math|r=<around*|(|r-<frac|P<around*|(|r|)>|P<rprime|'><around*|(|r|)>>|)><bmod>T<rsup|2<rsup|i>>>
      </indent>

      <strong|return> <math|r>
    </named-algorithm>

    \;

    <switch|<\shown>
      \;
    </shown>|<\hidden>
      <tabular*|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|2|2|cell-halign|l>|<table|<row|<cell|Step
      <math|0>:>|<cell|<math|r=0+\<cal-O\><around*|(|T|)>>>>|<row|<cell|Step
      <math|1>:>|<cell|<math|r=0+T+\<cal-O\><around*|(|T<rsup|2>|)>>>>|<row|<cell|Step
      <math|2>:>|<cell|<math|r=0+T+T<rsup|2>+2*T<rsup|3>+\<cal-O\><around*|(|T<rsup|4>|)>>>>>>>
    </hidden>|<\hidden>
      <greenblocktit|<strong|Remark.>|<math|P<rprime|'><around*|(|r|)>> is
      invertible since <math|P<rprime|'><around*|(|r|)>=P<rprime|'><around*|(|y<rsub|0>|)><modulo|T>>,
      which is non-zero.>
    </hidden>>
  </hidden>|<\hidden>
    <tit|Relaxed algorithms>

    \;

    \;

    <\definition*>
      <dueto|<em|on-line> or <em|relaxed> algorithm><em|[<name|Hennie> '66]>\ 

      <\center>
        <image|fig/online1.eps||||>

        \;
      </center>
    </definition*>

    \;

    \;

    \;

    \;
  </hidden>|<\hidden>
    <tit|Relaxed algorithms>

    \;

    \;

    <\definition*>
      <dueto|<em|on-line> or <em|relaxed> algorithm><em|[<name|Hennie> '66]>\ 

      <\center>
        <image|fig/online2.eps||||>

        \;
      </center>
    </definition*>
  </hidden>|<\hidden>
    <tit|Relaxed algorithms>

    \;

    \;

    <\definition*>
      <dueto|<em|on-line> or <em|relaxed> algorithm><em|[<name|Hennie> '66]>\ 

      <center|<image|fig/online3.eps||||>>

      \;
    </definition*>
  </hidden>|<\hidden>
    <tit|Relaxed algorithms>

    \;

    \;

    <\definition*>
      <dueto|<em|on-line> or <em|relaxed> algorithm><em|[<name|Hennie> '66]>\ 

      <center|<image|fig/online3.eps||||>>

      <strong|<em|Off-line> or <em|zealous> algorithm :> condition not met.
    </definition*>
  </hidden>|<\hidden>
    <tit|Example of relaxed algorithms>

    <strong|Relaxed Addition:> <specific|screen|**We regroup the computation
    step by step**>

    <tabular|<tformat|<cwith|1|1|2|2|cell-hyphen|t>|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|1|2|2|cell-hyphen|t>|<cwith|1|1|2|2|cell-valign|t>|<cwith|1|1|1|1|cell-hyphen|t>|<table|<row|<\cell>
      <\named-algorithm>
        <math|<math-tt|Add>>
      <|named-algorithm>
        <strong|Input: ><math|a,b\<in\>\<bbb-Q\><around*|[|<around*|[|T|]>|]>>
        and <math|n\<in\>\<bbb-N\>>

        <strong|Output: ><math|c\<in\>\<bbb-Q\><around*|[|<around*|[|T|]>|]>>
        such that <math|c=<around*|(|a+b|)><modulo|T<rsup|n>>>

        \;

        <\enumerate>
          <item><math|c=0>

          <item><strong|for> <math|i> from <math|0> to <math|n-1>

          <\enumerate>
            <item><math|c=<math|<math-tt|AddStep>><around*|(|a,b,c,i|)>>
          </enumerate>

          <item><strong|return> <math|c>
        </enumerate>
      </named-algorithm>
    </cell>|<\cell>
      <\named-algorithm>
        <math|<math-tt|AddStep>>
      <|named-algorithm>
        <strong|Input: ><math|a,b,c\<in\>\<bbb-Q\><around*|[|<around*|[|T|]>|]>>
        and <math|i\<in\>\<bbb-N\>>

        <strong|Output: ><math|c\<in\>\<bbb-Q\><around*|[|<around*|[|T|]>|]>>

        \;

        <\enumerate>
          <item><math|c=c+<around*|(|a<rsub|i>+b<rsub|i>|)>*T<rsup|i>>

          <item><strong|return> <math|c>
        </enumerate>
      </named-algorithm>
    </cell>>>>>

    \;

    \;

    <strong|Remarks.>

    <\enumerate>
      <item>Computations at step <math|i> complete those of previous steps to
      get a result modulo <math|T<rsup|i>>.

      <item>This addition algorithm is <em|online>:\ 

      <\itemize-arrow>
        <item>it outputs <math|c<rsub|i>> using <math|a<rsub|i>> and
        <math|b<rsub|i>>.
      </itemize-arrow>
    </enumerate>

    \;
  </hidden>|<\hidden>
    <tit|Example of relaxed algorithms>

    <strong|Naive Relaxed Multiplication:>

    <tabular|<tformat|<cwith|1|1|1|1|cell-hyphen|t>|<cwith|1|1|2|2|cell-hyphen|t>|<cwith|1|1|1|1|cell-valign|t>|<twith|table-width|1par>|<twith|table-hmode|exact>|<table|<row|<\cell>
      <\named-algorithm>
        <math|<math-tt|NaiveMulStep>>
      <|named-algorithm>
        <strong|Input: ><math|a,b,c\<in\>\<bbb-Q\><around*|[|<around*|[|T|]>|]>>
        and <math|i\<in\>\<bbb-N\>>

        <strong|Output: ><math|c\<in\>\<bbb-Q\><around*|[|<around*|[|T|]>|]>>

        \;

        <\enumerate>
          <item><strong|for> <math|j> from <math|0> to <math|i>

          <\enumerate>
            <item><math|c=c+a<rsub|j>*b<rsub|i-j>*T<rsup|i>>
          </enumerate>

          <item><strong|return> <math|c>
        </enumerate>
      </named-algorithm>
    </cell>|<\cell>
      <\named-algorithm>
        <math|<math-tt|NaiveMul>>
      <|named-algorithm>
        <strong|Input: ><math|a,b\<in\>\<bbb-Q\><around*|[|<around*|[|T|]>|]>>
        and <math|n\<in\>\<bbb-N\>>

        <strong|Output: ><math|c\<in\>\<bbb-Q\><around*|[|<around*|[|T|]>|]>>
        such that <math|c=<around*|(|a+b|)><modulo|T<rsup|n>>>

        \;

        <\enumerate>
          <item><math|c=0>

          <item><strong|for> <math|i> from <math|0> to <math|n-1>

          <\enumerate>
            <item><math|c=<math|<math-tt|NaiveMulStep>><around*|(|a,b,c,i|)>>
          </enumerate>

          <item><strong|return> <math|c>
        </enumerate>
      </named-algorithm>
    </cell>>>>>

    \;

    \;

    <strong|Remarks.>

    <\enumerate>
      <item>This multiplication algorithm is <em|online>:\ 

      <\itemize-arrow>
        <item>it outputs <math|c<rsub|i>> using
        <math|a<rsub|0>,\<ldots\>,a<rsub|i>> and
        <math|b<rsub|0>,\<ldots\>,b<rsub|i>>.
      </itemize-arrow>

      <item>Its complexity is <with|color|red|quadratic> !
    </enumerate>

    \;
  </hidden>|<\hidden>
    <tit|Fast relaxed multiplications>

    <\redblocktit|<strong|Problem.>>
      Karatsuba and FFT algorithms are offline.
    </redblocktit>

    <magentablocktit|<strong|Challenge.>|Find a <em|quasi-optimal on-line>
    multiplication algorithm.>

    <\blueblocktit|<strong|Theorem.><small|<htab|5mm>[<name|Fischer>,
    <name|Stockmeyer><nbsp>'74], [<name|Schrder> '97], [<name|van der
    Hoeven><nbsp>'97]<new-line> <htab|5mm>[<name|Berthomieu, van der Hoeven,
    Lecerf> '11], [<name|L., Schost> '13]>>
      <em|Let <math|<value|ssM><around*|(|N|)>> be the cost of
      <math|a\<times\>b> in <math|\<bbb-Q\><around*|[|<around*|[|T|]>|]>> at
      precision <math|N> by an off-line algorithm.<new-line>Let
      <math|<math-ss|R><around*|(|N|)>> be the cost of <math|a\<times\>b> in
      <math|\<bbb-Q\><around*|[|<around*|[|T|]>|]>> at precision <math|N> by
      an on-line algorithm. >

      <em|Then>

      <\equation*>
        <value|ssR><around*|(|N|)>=\<cal-O\><around*|(|<value|ssM><around*|(|N|)>*log
        N|)>=<wide|\<cal-O\>|~><around*|(|N|)>.
      </equation*>
    </blueblocktit>

    <switch|<\shown>
      \;
    </shown>|<\hidden>
      <\blueblocktit|<strong|Theorem.><htab|5mm><small|[<name|van der
      Hoeven><nbsp>'07, '12]>>
        <\equation*>
          <value|ssR><around*|(|N|)>=<value|ssM><around*|(|N|)>*log<around*|(|N|)><rsup|o<around*|(|1|)>>.
        </equation*>
      </blueblocktit>

      Seems not to be used yet in practice.
    </hidden>>
  </hidden>|<\hidden>
    <tit|Recursive power series>

    <\definition*>
      A power series <math|y\<in\>\<bbb-Q\><around*|[|<around*|[|T|]>|]>> is
      <with|color|blue|recursive> if there exists <math|\<Phi\>> such that

      <\indent>
        <\itemize-dot>
          <item><math|y=\<Phi\><around|(|y|)>>

          <item><math|\<Phi\><around|(|y|)><rsub|n>> only depends
          on<nbsp><math|y<rsub|0>,\<ldots\>,y<rsub|n-1>>
        </itemize-dot>
      </indent>
    </definition*>

    <math|\<rightsquigarrow\>> It is possible to compute <math|y> from
    <math|\<Phi\>> and <math|y<rsub|0>>. But how <with|color|red|fast>?

    <\Example>
      The solution <math|y> of <math|P<around*|(|Y|)>=Y<rsup|2>-Y+T> s.t.
      <math|y<rsub|0>=0> is <with|color|blue|recursive> (the other is too).

      <\proof>
        Let <math|\<Phi\><around*|(|Y|)>=Y<rsup|2>+T> then
        <math|y=\<Phi\><around*|(|y|)>>.

        Moreover,

        <\eqnarray*>
          <tformat|<table|<row|<cell|\<Phi\><around|(|y|)><rsub|n>=<around*|(|y<rsup|2>|)><rsub|n>+<around*|(|T|)><rsub|n>>|<cell|=>|<cell|y<rsub|0>*y<rsub|n>+y<rsub|1>*y<rsub|n-1>+\<cdots\>+y<rsub|n>*y<rsub|0>+\<delta\><rsub|1,n>>>|<row|<cell|>|<cell|=>|<cell|y<rsub|1>*y<rsub|n-1>+\<cdots\>+y<rsub|n-1>*y<rsub|1>+\<delta\><rsub|1,n>>>>>
        </eqnarray*>

        since <math|y<rsub|0>=0>. It does not depend on <math|y<rsub|n>>.
      </proof>
    </Example>
  </hidden>|<\hidden>
    <tit|Shifted Algorithms>

    <\orangeblocktit|<strong|Definition of <em|shifted algorithms>.>>
      <image|fig/shifted1.eps||||>
    </orangeblocktit>

    \;
  </hidden>|<\hidden>
    <tit|Shifted Algorithms>

    <\orangeblocktit|<strong|Definition of <em|shifted algorithms>.>>
      <image|fig/shifted2.eps||||>
    </orangeblocktit>

    \;
  </hidden>|<\hidden>
    <tit|Shifted Algorithms>

    <\orangeblocktit|<strong|Definition of <em|shifted algorithms>.>>
      <image|fig/shifted3.eps||||>
    </orangeblocktit>

    \;
  </hidden>|<\hidden>
    <tit|Shifted Algorithms>

    <\orangeblocktit|<strong|Definition of <em|shifted algorithms>.>>
      <image|fig/shifted3.eps||||>
    </orangeblocktit>

    \;

    <\Example>
      If <math|s\<gtr\>0>, then the Algorithm <verbatim|ShiftStep>:
      <math|a\<mapsto\>T<rsup|s>\<times\>a> is a shifted algorithm.

      <\named-algorithm|<verbatim|ShiftStep>>
        <strong|Input: ><math|a,c\<in\>R<rsub|p>>, <math|s\<in\>\<bbb-Z\>>
        and <math|i\<in\>\<bbb-N\>>

        <strong|Output:> <math|c\<in\>\<bbb-Q\><around*|[|<around*|[|T|]>|]>>

        <\enumerate>
          <item><math|c=c+a<rsub|i-s>*T<rsup|i>>

          <item><strong|return> <math|c>
        </enumerate>
      </named-algorithm>

      \;
    </Example>
  </hidden>|<\hidden>
    <tit|Example of shifted algorithm>

    \;

    \;

    <\Example>
      \;

      The online evaluation of <math|\<Psi\><around*|(|Y|)>=T<rsup|2>\<times\><around*|(|Y/T|)><rsup|2>+T>
      is shifted w.r.t. <math|Y>.

      \;

      <tabular*|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|2|2|cell-halign|l>|<cwith|1|-1|1|1|cell-halign|c>|<table|<row|<cell|>|<cell|<math|<around*|(|\<Psi\><around*|(|Y|)>|)><rsub|i>>>|<cell|>>|<row|<cell|requires>|<cell|<math|<around*|(|T<rsup|2>\<times\><around*|(|<around*|(|Y/T|)><rsup|2>|)>|)><rsub|i>>>|<cell|>>|<row|<cell|requires>|<cell|<math|<around*|(|<around*|(|Y/T|)><rsup|2>|)><rsub|i-2>>>|<cell|>>|<row|<cell|requires>|<cell|<math|<around*|(|Y/T|)><rsub|0>,\<ldots\>,<around*|(|Y/T|)><rsub|i-2>>>|<cell|using
      online multiplication>>|<row|<cell|requires>|<cell|<math|Y<rsub|0>,\<ldots\>,Y<rsub|i-1>>>|<cell|>>>>>
    </Example>
  </hidden>|<\hidden>
    <tit|Relaxed recursive power series>

    \;

    \;

    <blueblocktit|<strong|Fundamental Theorem.><htab|5mm><small|[<name|Watt>
    '88], [<name|van der Hoeven> '02], [<name|Berthomieu, L.> ISSAC
    '12]>|<em|Let <math|y\<in\>\<bbb-Q\><around*|[|<around*|[|T|]>|]>> such
    that <math|y=\<Phi\><around*|(|y|)>>. Given <math|y<rsub|0>> and
    <math|\<Phi\>>, we can compute <math|y> at precision <math|N> in the time
    necessary to evaluate <math|\<Phi\><around*|(|y|)>> by a
    <with|color|blue|shifted algorithm>.>>

    \;

    <\overlays-compressed|1|4>
      <\proof>
        <math|y=\<Phi\><around*|(|y|)>\<Rightarrow\>\<varphi\><rsub|0>=y<rsub|0>>

        <overlay-this|4|<image|fig/recursive4.eps||||>|>

        <overlay-this|3|<image|fig/recursive3.eps||||>|>

        <overlay-this|2|<image|fig/recursive2.eps||||>|>

        <overlay-this|1|<image|fig/recursive1.eps||||>|>
      </proof>
    </overlays-compressed>

    \;
  </hidden>|<\hidden>
    <tit|Relaxed recursive power series>

    <\overlays-phantoms|1|11>
      <\overlay-from|1>
        <\named-algorithm>
          <verbatim|OnlineRecursivePadic>
        <|named-algorithm>
          <strong|Input: >a shifted algorithm <math|\<b-Psi\>>, a modular
          root <math|\<b-y\><rsub|0>> and a precision <math|n\<in\>\<bbb-N\>>

          <strong|Output:> the lifted root <math|\<b-y\>> at precision
          <math|n>

          <\enumerate>
            <item><math|\<b-a\>=\<b-y\><rsub|0>>,
            <math|<around*|[|c<rsub|1>,\<ldots\>,c<rsub|L>|]>=<around*|[|0,\<ldots\>,0|]>>

            <item><strong|for> <math|i> from <math|1> to <math|n>

            <\indent>
              <\enumerate>
                <item>Perform the <math|i>th step of the evaluation of
                <math|\<b-Psi\>> on input <math|\<b-a\>>

                <item>Put the output in <math|\<b-a\>>
              </enumerate>
            </indent>

            <item><strong|return> <math|\<b-a\>>
          </enumerate>
        </named-algorithm>
      </overlay-from|>

      <\overlay-from|2>
        Computations of the lifting of the root <math|y> of
        <math|P<around*|(|Y|)>=Y<rsup|2>-Y+T> from <math|y<rsub|0>=0>:

        <block*|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<table|<row|<cell|<math|c<rsub|0>>>|<cell|<math|c<rsub|1>\<assign\>c<rsub|0>/T>>|<cell|<math|c<rsub|2>\<assign\>c<rsub|1><rsup|2>>>|<cell|<math|c<rsub|3>\<assign\>T<rsup|2>\<times\>c<rsub|2>>>|<cell|<math|c<rsub|4>\<assign\>c<rsub|3>+T>>|<cell|Step>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<math|<around*|(|i-2|)>>th
        step>|<cell|<math|<around*|(|i-2|)>>th step>|<cell|<math|i>th
        step>|<cell|<math|i>th step>|<cell|<math|i>th>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|<math|0>>|<cell|<overlay-from|3|<math|0>|>>|<cell|<overlay-from|3|<math|0>|>>|<cell|<overlay-from|3|<math|0>|>>|<cell|<overlay-from|3|<math|0>|>>|<cell|<math|1>st>>|<row|<cell|<overlay-from|4|<math|0>|>>|<cell|<overlay-from|5|<math|0>|>>|<cell|<overlay-from|5|<math|0>|>>|<cell|<overlay-from|5|<math|0>|>>|<cell|<overlay-from|5|<math|T>|>>|<cell|<math|2>nd>>|<row|<cell|<overlay-from|6|<math|T>|>>|<cell|<overlay-from|7|<math|1>|>>|<cell|<overlay-from|7|<math|1>|>>|<cell|<overlay-from|7|<math|T<rsup|2>>|>>|<cell|<overlay-from|7|<math|T+T<rsup|2>>|>>|<cell|<math|3>rd>>|<row|<cell|<overlay-from|8|<math|T+T<rsup|2>>|>>|<cell|<overlay-from|9|<math|1+T>|>>|<cell|<overlay-from|9|<math|1+2*T>|>>|<cell|<overlay-from|9|<math|T<rsup|2>+2*T<rsup|3>>|>>|<cell|<overlay-from|9|<math|T+T<rsup|2>+2*T<rsup|3>>|>>|<cell|<math|4>th>>|<row|<cell|<overlay-from|10|<math|T+T<rsup|2>+2*T<rsup|3>>|>>|<cell|<overlay-from|11|<math|1+T+2*T<rsup|2>>|>>|<cell|<overlay-from|11|<math|1+2*T+5*T<rsup|2>>|>>|<cell|<overlay-from|11|<math|T<rsup|2>+2*T<rsup|3>+5*T<rsup|4>>|>>|<cell|<overlay-from|11|<math|T+T<rsup|2>+2*T<rsup|3>+5*T<rsup|4>>|>>|<cell|<math|5>th>>>>>
      </overlay-from|>
    </overlays-phantoms>
  </hidden>|<\hidden>
    <\tit>
      Conclusion
    </tit>

    \;

    \;

    <strong|Two general paradigms:>

    <tabular*|<tformat|<cwith|1|1|1|-1|cell-bborder|4px>|<cwith|1|-1|1|1|cell-rborder|4px>|<cwith|1|-1|1|-1|cell-width|>|<cwith|1|-1|1|-1|cell-hmode|auto>|<twith|table-width|1par>|<twith|table-hmode|exact>|<table|<row|<cell|Newton
    operator>|<cell|Relaxed algorithms>>|<row|<cell|>|<cell|>>|<row|<cell|Solve
    implicit equations <math|P<around*|(|y|)>=0>>|<cell|Solve recursive
    equations <math|y=\<Phi\><around*|(|y|)>>>>|<row|<cell|>|<cell|>>|<row|<cell|Faster
    for higher precision>|<cell|>>|<row|<cell|>|<cell|Less on-line
    multiplications>>|<row|<cell|>|<cell|>>>>>

    \;

    <strong|Implementations:>

    Relaxed power series (and <math|T>-adics) in <name|Mathemagix>

    Beginning of a <verbatim|C++> package based on <name|NTL>

    \;

    \;
  </hidden>|<\hidden>
    \;

    \;

    \;

    \;

    \;

    \;

    <\with|par-mode|center>
      <strong|<with|font-base-size|17|Thank you for your attention ;-)>>
    </with>

    \;

    <\with|par-mode|center>
      <\with|font-base-size|17>
        <strong|>
      </with>
    </with>
  </hidden>|<\hidden>
    \;
  </hidden>|<\hidden>
    <tit|Example of shifted algorithm>

    <\Example>
      The evaluation Algorithm of <math|\<Psi\><around*|(|Y|)>=T<rsup|2>\<times\><around*|(|<around*|(|Y/T|)><rsup|2>|)>+T>
      is shifted.

      S.l.p. <math|\<Gamma\><rsub|1>=<around*|(|_/T;0|)>,\<Gamma\><rsub|2>=<around*|(|\<ast\>;1,1|)>,\<Gamma\><rsub|3>=<around*|(|T<rsup|2>\<times\>;2|)>,\<Gamma\><rsub|4>=<around*|(|+;3,T|)>>\ 

      Output sequence <math|<around*|[|c<rsub|0>,\<ldots\>,c<rsub|4>|]>> on
      input <math|c<rsub|0>=y> is <math|<around*|[|y,y/T,<around*|(|y/T|)><rsup|2>,T<rsup|2>\<times\><around*|(|<around*|(|Y/T|)><rsup|2>|)>,T<rsup|2>\<times\><around*|(|<around*|(|Y/T|)><rsup|2>|)>+T|]>>

      <\named-algorithm>
        <math|<math-tt|EvaluationStep>>
      <|named-algorithm>
        <strong|Input: ><math|a\<in\>\<bbb-Q\><around*|[|<around*|[|T|]>|]>>,
        <math|<around*|[|c<rsub|1><rsup|<around*|(|0|)>>,\<ldots\>,c<rsub|4><rsup|<around*|(|0|)>>|]>\<in\><around*|(|\<bbb-Q\><around*|[|<around*|[|T|]>|]>|)><rsup|4>>
        and <math|i\<in\>\<bbb-N\>>

        <strong|Output:> <math|<around*|[|c<rsub|1>,\<ldots\>,c<rsub|4>|]>\<in\><around*|(|\<bbb-Q\><around*|[|<around*|[|T|]>|]>|)><rsup|4>>

        <\enumerate>
          <item><math|c<rsub|0>=a>,<space|1em><math|<around*|[|c<rsub|1>,\<ldots\>,c<rsub|4>|]>=<around*|[|c<rsub|1><rsup|<around*|(|0|)>>,\<ldots\>,c<rsub|4><rsup|<around*|(|0|)>>|]>>

          <item>Evaluation of <math|\<Psi\>>:

          <\enumerate>
            <item><math|c<rsub|1>=<math-tt|ShiftStep><around*|(|a,c<rsub|1>,-1,i-2|)>>

            <item><math|c<rsub|2>=<math-tt|MulStep><around*|(|c<rsub|1>,c<rsub|1>,c<rsub|2>,i-2|)>>

            <item><math|c<rsub|3>=<math-tt|ShiftStep><around*|(|c<rsub|2>,c<rsub|3>,2,i|)>>

            <item><math|c<rsub|4>=<math-tt|AddStep><around*|(|c<rsub|3>,T,c<rsub|4>,i|)>>
          </enumerate>

          <item><strong|return> <math|<around*|[|c<rsub|1>,\<ldots\>,c<rsub|4>|]>>
        </enumerate>
      </named-algorithm>

      <math|<math-tt|EvaluationStep>> increase the precision by one of the
      evaluation of <math|\<Psi\>> on <math|y>.
    </Example>
  </hidden>>
</body>

<initial|<\collection>
</collection>>

<\references>
  <\collection>
    <associate|auto-1|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-10|<tuple|2|?>>
    <associate|auto-11|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-12|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-13|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-14|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-15|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-16|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-17|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-18|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-19|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-2|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-20|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-21|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-22|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-23|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-24|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-25|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-3|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-4|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-5|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-6|<tuple|2|?>>
    <associate|auto-7|<tuple|2|?>>
    <associate|auto-8|<tuple|2|?>>
    <associate|auto-9|<tuple|2|?>>
    <associate|eq:main|<tuple|2|?>>
    <associate|eq:qdiffmain|<tuple|1|?>>
    <associate|fig:1d|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|fig:2d|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|fig:semirelax|<tuple|1|?>>
    <associate|footnote-|<tuple|?|2>>
    <associate|li3|<tuple|2|?>>
    <associate|li4|<tuple|3|?>>
    <associate|li5|<tuple|4|?>>
    <associate|li6|<tuple|5|?>>
    <associate|li8|<tuple|7|?>>
    <associate|step:ORP3|<tuple|3|?>>
    <associate|step:ORP3a|<tuple|a|?>>
    <associate|step:ORP3b|<tuple|b|?>>
    <associate|theo:1|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
  </collection>
</references>